#pragma once

#include <jenga/include/smoothie/Namespace.h>

class NamespaceSupporter
{
	// ImportsꂽO
	NamespaceScopesCollection importedNamespaces;

	// ݂̖O
	NamespaceScopes livingNamespaceScopes;

public:
	NamespaceScopesCollection &GetImportedNamespaces()
	{
		return importedNamespaces;
	}
	void SetImportedNamespaces( const NamespaceScopesCollection &namespaces )
	{
		this->importedNamespaces = namespaces;
	}
	bool ImportsNamespace( const std::string &namespaceStr );

	NamespaceScopes &GetLivingNamespaceScopes()
	{
		return livingNamespaceScopes;
	}
	void SetLivingNamespaceScopes( const NamespaceScopes &namespaceScopes )
	{
		this->livingNamespaceScopes = namespaceScopes;
	}
	bool IsLiving( const NamespaceScopes &namespaceScopes ) const
	{
		return NamespaceScopes::IsBelong( namespaceScopes, livingNamespaceScopes );
	}


	// Ă邩`FbN
	// :
	// this =   "Discoversoft.ActiveBasic"
	// living = "Discoversoft.ActiveBasic"
	// entryName =   "ActiveBasic"
	// ̏ꍇAliving  entryName ĂB
	bool IsCoverd( const NamespaceScopes &namespaceScopes, const string &entryName ) const
	{
		if( namespaceScopes.IsEqual( entryName ) ){
			return true;
		}

		string thisStr = namespaceScopes.ToString();

		NamespaceScopes tempLivingNamespaceScopes = livingNamespaceScopes;

		while( tempLivingNamespaceScopes.size() ){
			NamespaceScopes tempNamespaceScopes = tempLivingNamespaceScopes;

			string tempStr = tempNamespaceScopes.ToString() + "." + entryName;
			if( thisStr == tempStr ){
				return true;
			}

			tempLivingNamespaceScopes.pop_back();
		}
		return false;
	}
	bool IsCoverd( const NamespaceScopes &baseNamespaceScopes, const NamespaceScopes &entryNamespaceScopes ) const
	{
		return IsCoverd( baseNamespaceScopes, entryNamespaceScopes.ToString() );
	}


	// w肳ꂽOԂGAƌȂ邩ǂ`FbN
	bool IsSameAreaNamespace( const NamespaceScopes &baseNamespaceScopes, const NamespaceScopes &entryNamespaceScopes ){
		if( entryNamespaceScopes.size() ){
			if( IsCoverd( baseNamespaceScopes, entryNamespaceScopes ) ){
				// ĂƂ͓ƌȂ
				return true;
			}
		}
		else{
			if( baseNamespaceScopes.size() ){
				// OԂ̔fKvȂƂ
				if( this->importedNamespaces.IsImported( baseNamespaceScopes )
					|| IsLiving( baseNamespaceScopes ) ){
					// Usingw肪Ƃ
					// ܂
					// w肳ꂽOԂ݂̖OԃXR[vƓ̂Ƃ
					return true;
				}
			}
			else{
				return true;
			}
		}

		return false;
	}

	static bool CollectNamespaces( const char *source, NamespaceScopesCollection &namespaceScopesCollection );
};
